package de.fraunhofer.iem.dataprovider.tools.gitlab.service

import de.fraunhofer.iem.dataprovider.gitlab.service.OpenCodeGitlabApi
import de.fraunhofer.iem.dataprovider.repository.dto.RepositoryDetailsDto
import de.fraunhofer.iem.dataprovider.tool.dto.CreateToolDto
import de.fraunhofer.iem.dataprovider.tool.entity.ToolEntity
import de.fraunhofer.iem.dataprovider.tool.service.ToolService
import org.springframework.stereotype.Service

@Service
class RepositoryDetailsService(private val openCodeGitlabApi: OpenCodeGitlabApi, private val toolService: ToolService) {

    suspend fun getRepositoryDetails(repoId: Long): RepositoryDetailsDto {
        return openCodeGitlabApi.getRepositoryDetails(repoId)
    }

    val toolEntity: ToolEntity = getOrCreateToolEntity()

    private final fun getOrCreateToolEntity(): ToolEntity {
        val createToolDto = CreateToolDto("Gitlab API")
        return toolService.findOrCreateTool(createToolDto)
    }
}
